include "Segment.inc"

ext InitSound_, SoundHandler
ext InitVram_
ext Main_

dseg
TimerCount: public TimerCount
    defb 0

cseg
    mov ah,2ah
    int 83h

    mov ax,2406h
    int 83h

    mov ax,2500h
    int 83h

    mov ah,0
    mov bx,0200ah
    mov cx,0004h
    mov dx,0ff01h
    int 8fh

    mov ax,0900h
    int 8fh

    mov si,PaletteValues
    mov al,0
    do
        push ax | push si
            mov ah,8
            mov cx,[si]
            int 8fh
        pop si | pop ax
        inc si | inc si
        inc al
        cmp al,16
    while nz | wend

    mov ax,0 ; Initialize sprites
    mov dx,1000h
    int 84h

    mov ax,0801h ; Show sprites
    int 84h

    mov dx,512h | xor al,al | out dx,al ; VRAM Block
    mov dx,518h | out dx,al ; Fixed Mode
    mov dx,514h | out dx,al ; Plane
    mov dx,516h | out dx,al ; Plane
    mov dx,510h | mov al,01h | out dx,al ; Extended access mode
    
    mov al,0f0h | mov dx,560h
    mov ah,4
    do
        out dx,al ; ROP
        inc dx | inc dx
        dec ah
    while nz | wend

    mov al,01h | out 40h,al
    mov al,7 | out 44h,al
    mov al,3fh | out 45h,al

    call InitVram_
    call InitSound_
    
    cli
        xor ax,ax | mov es,ax
        mov ax,Handler | mov [es:15h*4],ax
        mov ax,cs | mov [es:15h*4+2],ax

        mov dx,1a8h | mov al,81h | out dx,al
    sti
jmp Main_


Handler:
    push ax | push dx | push ds
        mov ax,cs | mov ds,ax
        inc byte ptr[TimerCount]
        call SoundHandler
        mov dx,184h | mov al,20h | out dx,al
    pop ds | pop dx | pop ax
iret


PaletteValues:
	defb	00h, 00h, 1eh, 00h, 0c0h, 03h, 0deh, 73h
	defb	00h, 0f0h, 1eh, 0f0h, 0c0h, 0f3h, 0deh, 0f3h
	defb	00h, 00h, 4eh, 0b3h, 46h, 03h, 46h, 52h
	defb	0d6h, 0d2h, 0eh, 70h, 0cah, 93h, 0d6h, 0b2h


WaitTimer_: public WaitTimer_
    push ax
        mov ah,al
        do
            mov al,[TimerCount]
            cmp al,ah
        while b | wend
        cli
            mov byte ptr [TimerCount],0
        sti
    pop ax
ret


DebPrintC_: public DebPrintC_
    push ax
    push cx
    push dx
    push bp
        mov dl,al
        mov dh,0
        mov ah,0
        int 83h
    pop bp
    pop dx
    pop cx
    pop ax
ret

DebPrintXC:
    cmp al,10
    if c
        add al,'0'
    else
        add al,'A'-10
    endif
    call DebPrintC_
ret

DebPrintX: public DebPrintX
    push ax
        shr al,1 | shr al,1 | shr al,1 | shr al,1
        call DebPrintXC
    pop ax
    and al,0fh
    call DebPrintXC
ret


DebPrintDX: public DebPrintDX
    push ax
        mov al,ah
        call DebPrintX
    pop ax
jmp DebPrintX
