#include "Vram.h"
#include "VVram.h"
#include "Chars.h"
#include "Sound.h"
#include "Sprite.h"
#include "Star.h"
#include "EnemyRow.h"

extern byte[] MonoPatternSource, ColorPatternSource, SpritePatternSource;
bool BackgroundChanged;


void InitVram()
{
    InitMonoPattern();
    InitColorPattern();
    InitStarPattern();
    InitEnemyPattern();
    InitSpritePattern();
}


void DrawAll()
{
    if (BackgroundChanged) {
        BackgroundChanged = false;
        ClearVVram();
        DrawStars();
        DrawEnemyRows();
        VVramToVram();
    }
    // SwapVram();
}


word PrintC(word vram, byte c)
{
    return Put(vram, c - ' ');
}


word Put2C(word vram, byte c)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, c);
            ++c;
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}


word Erase2(word vram)
{
    repeat (2) {
        repeat (2) {
            vram = Put(vram, Char_Space);
        }
        vram += VramRowSize - 2 * VramStep;
    }
    return vram + 2 * VramStep - VramRowSize * 2;
}
