include "Vram.inc"
include "Segment.inc"
include "Chars.inc"

ext MonoPatternSource, ColorPatternSource, EnemyPatternSource
ext VVram_
ext EnemyRowLeft_

PlaneCount equ 4
EnemyCharRam equ CharRam+CharHeight*Char_Enemy


dseg
Backup: public Backup
	defs WindowWidth*WindowHeight


cseg
SelG:
    mov dx,0153h
    in al,dx | and al,0f0h | or al,4 | out dx,al
ret
SelT:
    mov dx,0153h
    in al,dx | and al,0f0h | or al,1 | out dx,al
ret
FixedMode:
    xor al,al | mov dx,518h | out dx,al ; Fixed Mode
ret
ReadingMem:
    mov al,1 | mov dx,518h | out dx,al ; Update when reading memory
ret

; void InitMonoPattern();
cseg
ColorSource:
	defb 64,7
	defb 16,5
	defb 0
InitMonoPattern_: public InitMonoPattern_
	push ax | push cx | push dx | push bx | push si | push di
        call SelG
        call FixedMode
            mov ax,VramSegment | mov es,ax
            mov bx,ColorSource
            mov di,CharRam
            mov si,MonoPatternSource
            do
                mov cl,[bx] | inc bx
                or cl,cl
            while nz
                mov dh,[bx] | inc bx
                push bx
                    do
                        mov ch,8 ; v count
                        do
                            mov bl,dh
                            push dx
                                mov dx,530h
                                mov bh,PlaneCount
                                do
                                    mov ah,[si]
                                    xor al,al
                                    test bl,01h
                                    if nz
                                        or al,ah
                                    endif
                                    test bl,10h
                                    if nz
                                        not ah
                                        or al,ah
                                        not ah
                                    endif
                                    out dx,al | inc dx | inc dx
                                    
                                    shr bl,1
                                    dec bh
                                while nz | wend
                            pop dx
                            mov [es:di],al | inc di
                            inc si
                            dec ch
                        while nz | wend
                        dec cl
                    while nz | wend
                pop bx
            wend
        call SelT
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret


; void InitColorPattern();
cseg
InitColorPattern_: public InitColorPattern_
	push ax | push cx | push dx | push si | push di
        call SelG
        call FixedMode
            mov di,CharRam+CharHeight*Char_Remain
            mov si,ColorPatternSource
            mov ax,VramSegment | mov es,ax
            mov cx,CharHeight*(Char_Enemy-Char_Remain)
            do
                push cx
                    mov dx,530h
                    mov cl,PlaneCount
                    do
                        mov al,[si] | inc si
                        out dx,al | inc dx | inc dx
                        dec cl
                    while nz | wend
                    mov [es:di],al | inc di
                pop cx
            wloop
        call SelT
	pop di | pop si | pop dx | pop cx | pop ax
ret


; void InitStarPattern();
cseg
InitStarPattern_: public InitStarPattern_
	push ax | push cx | push dx | push bx
        call SelG
        call FixedMode
        mov ax,VramSegment | mov es,ax
            mov bx,CharRam+CharHeight*Char_Star
            mov ch,0
            do
                mov ah,ch
                or ah,ah
                do | while nz
                    xor al,al
                    mov dx,530h
                    mov cl,PlaneCount
                    do
                        out dx,al | inc dx | inc dx
                        dec cl
                    while nz | wend
                    mov word ptr[es:bx],al | inc bx
                    dec ah
                wend
                
                mov al,10h
                mov dx,530h
                mov cl,PlaneCount
                do
                    out dx,al | inc dx | inc dx
                    dec cl
                while nz | wend
                mov word ptr[es:bx],al | inc bx

                mov ah,7
                sub ah,ch
                do
                    xor al,al
                    mov dx,530h
                    mov cl,PlaneCount
                    do
                        out dx,al | inc dx | inc dx
                        dec cl
                    while nz | wend
                    mov word ptr[es:bx],al | inc bx
                    dec ah
                while nz | wend
                inc ch
                cmp ch,8
            while nz | wend
        call SelT
	pop bx | pop dx | pop cx | pop ax
ret


; void InitEnemyPattern();
EnemyTypeCount equ 3
dseg
rShift:
	defb 0
lShift:
	defb 0
cseg
InitEnemyPattern_: public InitEnemyPattern_
	push ax | push bx | push cx | push dx | push si | push di
        call SelG
        call FixedMode
        mov ax,VramSegment | mov es,ax
            mov di,EnemyCharRam
            mov si,EnemyPatternSource
            mov ch,EnemyTypeCount
            do
                push cx
                    ; left side (left is space)
                    mov bh,2
                    do
                        xor cl,cl
                        do
                            mov bl,CharHeight
                            do
                                mov dx,530h
                                mov ch,PlaneCount
                                do
                                    mov al,[si] | inc si
                                    shr al,cl
                                    out dx,al | inc dx | inc dx
                                    dec ch
                                while nz | wend
                                mov [es:di],al | inc di
                                dec bl
                            while nz | wend
                            sub si,CharHeight*PlaneCount
                            inc cl
                            cmp cl,8
                        while nz | wend
                        add si,CharHeight*2*PlaneCount
                        dec bh
                    while nz | wend
                    add si,CharHeight*(-4+1)*PlaneCount

                    ; right side (right is space)
                    mov bh,2
                    do
                        mov cl,7
                        do
                            mov bl,CharHeight
                            do
                                mov dx,530h
                                mov ch,PlaneCount
                                do
                                    mov al,[si] | inc si
                                    shl al,cl
                                    out dx,al | inc dx | inc dx
                                    dec ch
                                while nz | wend
                                mov [es:di],al | inc di
                                dec bl
                            while nz | wend
                            sub si,CharHeight*PlaneCount
                            dec cl
                            cmp cl,-1
                        while nz | wend
                        add si,CharHeight*2*PlaneCount
                        dec bh
                    while nz | wend
                    add si,CharHeight*(-5)*PlaneCount

                    ; left side (left is not space)
                    mov bh,2
                    do
                        xor cl,cl
                        do
                            mov bl,CharHeight
                            do
                                mov dx,530h
                                mov ch,PlaneCount
                                do
                                    mov al,[si]
                                    mov ah,[si+CharHeight*PlaneCount]
                                    inc si
                                    shr ax,cl
                                    out dx,al | inc dx | inc dx
                                    dec ch
                                while nz | wend
                                mov [es:di],al | inc di
                                dec bl
                            while nz | wend
                            sub si,CharHeight*PlaneCount
                            inc cl
                            cmp cl,8
                        while nz | wend
                        add si,CharHeight*2*PlaneCount
                        dec bh
                    while nz | wend
                    add si,CharHeight*(-4+1)*PlaneCount

                    ; right side (right is not space)
                    mov bh,2
                    do
                        mov cl,7
                        do
                            mov bl,CharHeight
                            do
                                mov dx,530h
                                mov ch,PlaneCount
                                do
                                    mov al,[si]
                                    mov ah,[si-CharHeight*PlaneCount]
                                    inc si
                                    shl ax,cl
                                    xchg ah,al
                                    out dx,al | inc dx | inc dx
                                    dec ch
                                while nz | wend
                                mov [es:di],al | inc di
                                dec bl
                            while nz | wend
                            sub si,CharHeight*PlaneCount
                            dec cl
                            cmp cl,-1
                        while nz | wend
                        add si,CharHeight*2*PlaneCount
                        dec bh
                    while nz | wend
                    add si,CharHeight*(-1)*PlaneCount
                pop cx
                dec ch
            while nz | wend

        call SelT
	pop di | pop si | pop dx | pop cx | pop bx | pop ax
ret



; void ClearScreen();
cseg
ClearScreen_:  public ClearScreen_
	push ax | push bx | push cx | push dx | push di
        call SelG
        call FixedMode

            mov dx,530h
            xor al,al
            mov bl,PlaneCount
            do
                out dx,al
                inc dx | inc dx
                dec bl
            while nz | wend

            mov ax,VramSegment | mov es,ax
            mov di,Vram
            mov cx,VramRowSize*VramHeight
            do
                mov word ptr[es:di],al | inc di
            wloop
        call SelT
    pop di | pop dx | pop cx | pop bx | pop ax
ret


; ; word VramAddress(byte x, byte y);
; cseg
; VramAddress_: public VramAddress_
;     push dx
;         mov dh,al
;         mov al,VramWidth
;         mul dl
;         add ax,ax ;*2
;         add ax,ax ;*4
;         add ax,ax ;*8
;         mov dl,dh
;         xor dh,dh
;         add ax,dx
;     pop dx
; ret


cseg
Put: ; (di, al)
    push cx | push dx | push si
        cmp al,Char_Enemy
        if c
            mov ah,CharHeight | mul ah
            add ax,CharRam
        else
            sub al,Char_Enemy
            mov ah,CharHeight | mul ah
            mov dl,[EnemyRowLeft_] | and dl,7
            xor dh,dh
            add ax,dx
            shl ax,1 | shl ax,1 | shl ax,1
            add ax,EnemyCharRam
        endif
        mov si,ax

        mov ax,VramSegment | mov es,ax
        mov ch,CharHeight
        do
            mov al,[es:si] | inc si
            mov [es:di],al
            add di,VramWidth
            dec ch
        while nz | wend
    pop si | pop dx | pop cx
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push ax | push dx
        call SelG
        call ReadingMem
    pop dx | pop ax
    push ax | push di
        mov di,ax
        mov al,dl
        call Put
    pop di | pop ax
    push ax | push dx
        call SelT
    pop dx | pop ax
    inc ax
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
	push ax | push cx | push dx | push bx | push si | push di
        call SelG
        call ReadingMem
            mov bx,VVram_
            mov si,Backup
            mov di,Vram
            mov ch, WindowHeight
            do
                mov cl,WindowWidth
                do 
                    mov al,[bx] | inc bx
                    cmp al,Char_Enemy
                    jae VVramToVram_draw
                    cmp al,[si]
                    if ne
                        VVramToVram_draw:
                        mov [si],al
                        push si | push di
                            call Put
                        pop di | pop si
                    endif
                    add di,VramStep
                    inc si
                    dec cl
                while nz | wend
                add di,VramRowSize-WindowWidth*VramStep
                dec ch
            while nz | wend
        call SelT
	pop di | pop si | pop bx | pop dx | pop cx | pop ax
ret 